<?

/* Shop-Funktionen */

// Session und Sprachdetektion
function create_session($id, $lan, $REMOTE_ADDR, $SERVER_NAME, $SERVER_PORT, $SCRIPT_NAME, $languages, $HTTP_ACCEPT_LANGUAGE, $default_lan)
	{
	//global $lan;
	$client_lan = explode(",", $HTTP_ACCEPT_LANGUAGE);  // Welche Sprachen akzeptiert der Browser?
	for($i=0; $i<count($client_lan); $i++)
		{
		if(!$lan)
			{
			reset($languages); // Welche Sprachen sind im Angebot?
			while(list($lan, $lan_file) = each($languages))
				{
    			if(stristr($client_lan[$i],$lan))
					{
					break;// Beim 1. Treffer reichts
					}
				}
			}
		}
	if(!$lan) // Da passt nix also die default-Sprache
		{
		$lan=$default_lan;
		}
	if(!@$id) // Erzeugung einer eindeutigen Session-ID und Aufruf der Startseite
		{
		mt_srand((double)microtime()*1000000);
		$id = md5(str_replace(".","",$REMOTE_ADDR) + mt_rand(100000,999999));
		header("Location: http://".$SERVER_NAME.":".$SERVER_PORT.$SCRIPT_NAME."?id=$id&lan=$lan");
		header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
		header("Last-Modified: " . gmdate("D, d M Y H H:i:s") . " GMT");
		header("Cache-Control: no-cache, must-revalidate, post-check=0, pre-check=0");
		header("Pragma: no cache");
		setcookie("id", $id, time()+7200);
		}
	}

// Sprachdatei laden
function select_language($lan, $languages, $lan_path, $default_lan, $default_lan_file)
	{
	global $inc_lan;
	reset($languages); // Welche Sprachen sind im Angebot?
	while(list($lang, $lan_file) = each($languages))
		{
		if($lang==$lan)
			{
			$inc_lan=$lan_path.$lan_file;
			//break;
			}
		else
			{
			$inc_lan=$lan_path.$default_lan_file;
			}
		}
	}

/* Datenzugriff, Korb anzeigen, Menge aendern, Artikel loeschen */

// Warenkorb und andere Infos anzeigen
function get_data($datei)
	{
	global $data, $zeile, $spalte;
	if(@file_exists($datei)) // Wenn es die Datei gibt...
		{
		$zeile=file($datei);
		sort($zeile);
		for($i=0;$i<count($zeile); ++$i)
			{
			$spalte=explode("|", $zeile[$i]);
			$data[$i]=$spalte;
			}
		}
	}

// Warenkorb aktualisieren
function aktu_data($datei, $action, $in_cart, $menge, $pos)
	{
	global $HTTP_REFERER, $HTTP_HOST;
	if(($action=="aktu")&&(file_exists($datei))&&(@stristr($HTTP_REFERER, $HTTP_HOST))) // Wenn es einen Warenkorb gibt...
		{
		$fp_new = @fopen ("$datei.new","a") or die ($meld=$meld5); // Korbdatei oeffnen...
		for($i=0;$i<$pos; ++$i)
			{
			if ($in_cart[$i."_7"]==1) // Checkbox Loeschen = 1: Zeile loeschen
			continue;
			elseif($menge[$i."_3"]=="0") // Menge = 0: Zeile loeschen
			continue;
			if(preg_match("/^[0-9]+$/",$menge[$i."_3"])) // Fehlerhafte Menge aendern
				{
				$menge[$i."_3"];
				}
			else
				{
				$menge[$i."_3"]=1;
				}
			fputs($fp_new, (rawurldecode($in_cart[$i."_0"])."|".rawurldecode($in_cart[$i."_1"])."|".rawurldecode($in_cart[$i."_2"])."|".$menge[$i."_3"]."|".rawurldecode($in_cart[$i."_4"])."|".$in_cart[$i."_5"]."|".$in_cart[$i."_6"]."|\n"));
			}
		unlink ($datei); // Alte Korbdatei loeschen
		fclose($fp_new);
		rename($datei.".new", $datei); // Korbdatei.new umbennen in alte Korbdatei ("close" vor "rename" --> Win)
		}
	}

// Warenkorb loeschen
function del_all($action, $datei) // action==delall: Alles loeschen
	{
	if((file_exists($datei))&&($action=="delall")) // Wenn es einen Warenkorb gibt...
		{
		unlink ($datei); // Alte Korbdatei loeschen
		}
	}

// Warenkorb erstellen, wenn noch nicht vorhanden und Artikel einpacken
function add_item($action, $korbid, $artnr, $artbz, $ausfue, $einheit, $preis, $mwst, $menge)
	{
	global $meld, $melda, $meld2, $meld2a, $meld3, $meld5, $HTTP_REFERER, $HTTP_HOST;
	if(($action=="pack")&&(@stristr($HTTP_REFERER, $HTTP_HOST))) // action==pack: Einpacken
		{
		if(file_exists($korbid)) // Wenn es einen Warenkorb gibt...
			{
    	    $fp = fopen ("$korbid","r+") or die ($meld5); // Korbdatei oeffnen...
        	while ($in_cart = fgetcsv ($fp, 4096, "|"))
				{
				if (ereg($in_cart[0].$in_cart[1].$in_cart[2], rawurldecode($artnr.$artbz.$ausfue))) // Nachschauen, ob Artikel bereits im Korb sind...
					{
					$meld="$meld2"; // ... wenn ja
					$melda="$meld2a"; // ... wenn ja (JavaScript-Alert)
					$exist=1;
					}
				}
			if ($exist !=1)
				{
				if((preg_match("/^[0-9]+$/",$menge))&&($menge>0)) // Fehlerhafte Menge aendern
					{
					$menge;
					}
				else
					{
					$menge=1;
					}
				fputs($fp, rawurldecode($artnr)."|".rawurldecode($artbz)."|".rawurldecode($ausfue)."|$menge|".rawurldecode($einheit)."|$preis|$mwst|\n");
				$meld="$meld3";
				$melda="$meld3";  // (JavaScript-Alert)
				}
			fclose($fp);
			}
		else // Wenn es keinen Warenkorb gibt... 
			{
			$fp = fopen ("$korbid","a") or die ($meld5); // ...erstellen und einpacken
			if((preg_match("/^[0-9]+$/",$menge))&&($menge>0)) // Fehlerhafte Menge aendern
				{
				$menge;
				}
			else
				{
				$menge=1;
				}
			fputs($fp, rawurldecode($artnr)."|".rawurldecode($artbz)."|".rawurldecode($ausfue)."|$menge|".rawurldecode($einheit)."|$preis|$mwst|\n");
			$meld="$meld3";
			$melda="$meld3";  // (JavaScript-Alert)
			fclose($fp);
			}
		}
	}

// Ausgabe der Links fuer weitere Infos
function echo_link($link, $text, $directory)
	{
	global $list_item, $maintarget, $lan, $id, $root_web_path;
	echo
	"<tr class=\"left\" align=\"left\" valign=\"top\">\n",
	"<td class=\"left\"><li type=\"square\" class=\"left\">&nbsp;</td>\n",
	"<td class=\"left\">\n",
	"<a href=\"text.php3?id=$id&lan=$lan&inc=$root_web_path$directory$link&no_cache=".md5(uniqid(rand()))."\" target=\"$maintarget\"class=\"left\">$text</a>\n",
	"</td>\n",
	"</tr>\n";
    }

// Generierung der Links fuer weitere Infos
function build_menu($dir_name, $directory)
	{
	$d = dir($dir_name);
	chdir($dir_name);
    while($file=$d->read())
		{
		if ((is_file($file)) && (eregi("php3$", $file) or eregi("htm", $file)))
			{
			$fp = fopen("$file", "r");
        	$build = "";
        	$flag = 0;
        	for ($i = 0; !feof($fp); $i++)
				{
            	$line = fgets($fp, 1024);
				if (eregi("<!--<title>", $line))
            	$flag = 1;
            	if ($flag == 1)
            	$build = $build.$line;
            	if (eregi("</title>-->", $line))
            	$flag = 0;
            	}
            if ($build > "")
				{
    	        $build = eregi_replace("<!--<title>", "", $build);
        	    $build = eregi_replace("</title>-->", "", $build);
            	$build = trim($build);
            	echo_link($file, $build, $directory);
            	}
			}
		}
	//chdir("/../");
	$d->close();
    }

// Garbage remover
function del_garbage($garbage_path, $min_garbage)
	{
	if(@$min_garbage > 0)
		{
		@$fp = opendir($garbage_path);
		$del = ($min_garbage*60);
		$muell = mktime() - ($del); 
    	while($file=readdir($fp))
			{
        	if (ereg(".cart$", $file))
		 		{
           		if (filemtime("$garbage_path$file") < $muell)
					{
            		unlink("$garbage_path$file");
           			}
         		}
       		}
		}
	}

// Bestellung abschicken
function send_order($c_mail, $s_mail, $subject, $c_message, $s_message, $c_additional, $s_additional)
	{
	global $action;
	mail("$c_mail", "$subject", $c_message, $c_additional); // Bestellung an den Kunden schicken
	mail("$s_mail", "$subject", $s_message, $s_additional); // Bestellung an den Verkaeufer schicken
	$action="delall"; // Warenkorb loeschen
	return $action;
	}

/* Ausgabe Seitenkoepfe und -fuesse */
function kopf_top() // Kopfframe
	{
	global $id, $lan, $title ,$back_top, $bg_top, $text_top, $li_top, $vli_top, $ali_top, $root_web_path, $template_css, $top_css;
	header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
	header("Last-Modified: " . gmdate("D, d M Y H H:i:s") . " GMT");
	header("Cache-Control: no-cache, must-revalidate, post-check=0, pre-check=0");
	header("Pragma: no cache");
	echo
	"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\">\n",
	"<html>\n",
	"<head>\n",
	"<title>$title</title>\n",
	"<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\n",
	"<meta http-equiv=\"Last-Modified:\" content=\"Mon, 26 Jul 1997 05:00:00 GMT\">\n",
	"<meta http-equiv=\"Expires\" content=\"". gmdate("D, d M Y H H:i:s") . " GMT\">\n",
	"<meta http-equiv=\"Cache-Control\" content=\"no-cache, must-revalidate, post-check=0, pre-check=0\">\n",
	"<meta http-equiv=\"Pragma\" content=\"no-cache\">\n",
	"<style type=\"text/css\">\n",
 	"<!--\n";
	include "$root_web_path$template_css$top_css";
	echo
	"-->\n",
	"</style>\n",
	"</head>\n",
	"<body background=\"$back_top\" bgcolor=\"$bg_top\" text=\"$text_top\" link=\"$li_top\" vlink=\"$vli_top\" alink=\"$ali_top\" marginwidth=3 marginhight=1 leftmargin=5 topmargin=1 class=\"top\">\n";
	}

function fuss_top() // Kopfframe
	{
	echo 
	"</body>\n</html>";
	}

function kopf_left() // Linker Frame
	{
	global $id, $lan, $title ,$back_left, $bg_left, $text_left, $li_left, $vli_left, $ali_left, $root_web_path, $template_css, $left_css;
	header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
	header("Last-Modified: " . gmdate("D, d M Y H H:i:s") . " GMT");
	header("Cache-Control: no-cache, must-revalidate, post-check=0, pre-check=0");
	header("Pragma: no cache");
	echo
	"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\">\n",
	"<html>\n",
	"<head>\n",
	"<title>$title</title>\n",
	"<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\n",
	"<meta http-equiv=\"Last-Modified:\" content=\"Mon, 26 Jul 1997 05:00:00 GMT\">\n",
	"<meta http-equiv=\"Expires\" content=\"". gmdate("D, d M Y H H:i:s") . " GMT\">\n",
	"<meta http-equiv=\"Cache-Control\" content=\"no-cache, must-revalidate, post-check=0, pre-check=0\">\n",
	"<meta http-equiv=\"Pragma\" content=\"no-cache\">\n",
	"<style type=\"text/css\">\n",
 	"<!--\n";
	include "$root_web_path$template_css$left_css";
	echo
	"-->\n",
	"</style>\n",
	"</head>\n",
	"<body background=\"$back_left\" bgcolor=\"$bg_left\" text=\"$text_left\" link=\"$li_left\" vlink=\"$vli_left\" alink=\"$ali_left\" marginwidth=3 marginhight=5 leftmargin=5 topmargin=5 class=\"left\">\n";
	}

function fuss_left() // Linker Frame
	{
	echo 
	"</body>\n</html>";
	}

function kopf_main() // Hauptframe
	{
	global $id, $lan, $title, $back_main, $bg_main, $text_main, $li_main, $vli_main, $ali_main, $root_web_path, $template_css, $main_css;
	header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
	header("Last-Modified: " . gmdate("D, d M Y H H:i:s") . " GMT");
	header("Cache-Control: no-cache, must-revalidate, post-check=0, pre-check=0");
	header("Pragma: no cache");
	mt_srand((double)microtime()*1000000);
	$no_cache = mt_rand();
	echo
	"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\">\n",
	"<html>\n",
	"<head>\n",
	"<title>$title</title>\n",
	"<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\n",
	"<meta http-equiv=\"Last-Modified:\" content=\"Mon, 26 Jul 1997 05:00:00 GMT\">\n",
	"<meta http-equiv=\"Expires\" content=\"". gmdate("D, d M Y H H:i:s") . " GMT\">\n",
	"<meta http-equiv=\"Cache-Control\" content=\"no-cache, must-revalidate, post-check=0, pre-check=0\">\n",
	"<meta http-equiv=\"Pragma\" content=\"no-cache\">\n",
	"<style type=\"text/css\">\n",
 	"<!--\n";
	include "$root_web_path$template_css$main_css";
	echo
	"-->\n",
	"</style>\n";
	include "main.js";
	echo
	"</head>\n",
	"<body background=\"$back_main\" bgcolor=\"$bg_main\" text=\"$text_main\" link=\"$li_main\" vlink=\"$vli_main\" alink=\"$ali_main\" class=\"main\" marginwidth=5 marginhight=5 leftmargin=0 topmargin=5 onLoad=\"javascript:EinFrame('top.php3?id=$id&lan=$lan&no_cache=".md5(uniqid(rand()))."',0)\">\n";
	}

function kopf_main_order() // Hauptframe Bestellbereich
	{
	global $id, $lan, $title, $back_main, $bg_main, $text_main, $li_main, $vli_main, $ali_main, $root_web_path, $template_css, $main_css;
	header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
	header("Last-Modified: " . gmdate("D, d M Y H H:i:s") . " GMT");
	header("Cache-Control: no-cache, must-revalidate, post-check=0, pre-check=0");
	header("Pragma: no cache");
	mt_srand((double)microtime()*1000000);
	$no_cache = mt_rand();
	echo
	"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\">\n",
	"<html>\n",
	"<head>\n",
	"<title>$title</title>\n",
	"<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\n",
	"<meta http-equiv=\"Last-Modified:\" content=\"Mon, 26 Jul 1997 05:00:00 GMT\">\n",
	"<meta http-equiv=\"Expires\" content=\"". gmdate("D, d M Y H H:i:s") . " GMT\">\n",
	"<meta http-equiv=\"Cache-Control\" content=\"no-cache, must-revalidate, post-check=0, pre-check=0\">\n",
	"<meta http-equiv=\"Pragma\" content=\"no-cache\">\n",
	"<style type=\"text/css\">\n",
 	"<!--\n";
	include "$root_web_path$template_css$main_css";
	echo
	"-->\n",
	"</style>\n";
	include "main.js";
	echo
	"</head>\n",
	"<body background=\"$back_main\" bgcolor=\"$bg_main\" text=\"$text_main\" link=\"$li_main\" vlink=\"$vli_main\" alink=\"$ali_main\" class=\"main\" marginwidth=5 marginhight=5 leftmargin=0 topmargin=5>\n";
	}

function fuss_main() // Hauptframe
	{
	echo_debug_info($debug, $HTTP_HOST, $HTTP_REFERER, $HTTP_POST_VARS, $root_web_path, $shop_path, $daten_pfad, $korbid, $text_path, $korb_path);
	echo
	"</body>\n</html>";
	}

/* Debug-Funktionen (debug = 1 --> config.php3) */

// HTTP POST VARS anzeigen (debug)
function echo_post_vars($HTTP_POST_VARS)
	{
	if ($HTTP_POST_VARS)
		{
		echo "<br><b>HTTP POST VARS:</b><br>";
		reset ($HTTP_POST_VARS);
		while (list ($key, $val) = each ($HTTP_POST_VARS))
			{
    		echo "<b>$key:</b> $val<br>";
			}
		echo "<br>&nbsp;<br>";
		}
	}

// Korb-Verzeichniss listen (debug)
function show_dir($dir, $pos=2)
	{
     if($pos == 2)
		{
        echo "<b>Listing-Warenkorbverzeichnis:</b><br><pre>";
     	}
     $handle = @opendir($dir);
     while ($file = @readdir ($handle)) 
		{
        if (eregi("^\.{1,2}$",$file))
        	{
          	continue;
        	}
        if(is_dir($dir.$file))
   			{
          	printf ("% ".$pos."s <b>%s</b>\n", "|-", $file);
          	show_dir($dir.$file."/", $pos + 3);               
        	}
        else
        	{
          	printf ("% ".$pos."s %s\n", "|-", $file);
        	}
		}
     @closedir($handle); 
     if($pos == 2)
	 	{
        echo "</pre>";
     	}
	}

// Debug-Info ausgeben
function echo_debug_info($debug, $HTTP_HOST, $HTTP_REFERER, $HTTP_POST_VARS, $root_web_path, $shop_path, $daten_pfad, $korbid, $text_path, $korb_path)
	{
	if($debug==1):
	echo
	"<p><font color=\"#FF0000\"><b><u>Debug-Info:</u></b><br>",
	"<b>Datum:</b> ".date("d.m.Y")."&nbsp;&nbsp;".date("G:i:s")."<br>",
	"<b>HTTP HOST:</b> $HTTP_HOST<br>",
	"<b>HTTP REFERER:</b> $HTTP_REFERER<br>",
	"<b>DOCUMENT ROOT:</b>$DOCUMENT_ROOT<br>",
	"<b>Web-Root:</b> $root_web_path<br>",
	"<b>Shop-Verzeichnis:</b> $shop_path<br>",
	"<b>Pfad zu den Daten:</b> $daten_pfad<br>",
	"<b>Pfad zum Warenkorb:</b> $korbid<br>",
	"<b>Pfad zu den Zusatzinformationen:</b> $text_path<br>";
	echo_post_vars($HTTP_POST_VARS);
	show_dir("$korb_path");
	echo
	"</font></p>";
	endif;
	}

?>